#include "prep_spec.i"
#include "prep_arf.i"
#include "attach_std_arf.i"
#include "arrange_fit.i"
#include "jkve/xb.i"
#include "get_xspec_fit_params.i"

vrest,rebin,"crabrebin3.ysav";

ofax = [3.5, 1.43, 4.0, 4.41, 4.9, 5.45, 5.7, 6.7, 4.3, 4.4, 2.0, 1.2, 1.4, 0.7, 5.3 ];
// sort order:
//       4     2    5     7    9    11    12   13   6    8    3    1             10
// crab data  serial number:
//      21    22   23    24   25    26    27   28  29   30   31   32    33   34  35
detno= [ 3,    0,   2,    1,   0,    3,    1,   1,  2,   0,   0,   0,    0,  0,   3];

func crabfit( fmodel, rrxo, rsig, oaa, outfile= )
/* DOCUMENT crabfit, fmodel, rrxo, rsig, oaa, outfile=
*/
{
   if( allof([1,2]-fmodel)) error,"##1## Bad fmodel value";
   if( allof([120,240,318]-oaa)) error,"##2## Bad oaa value";
   if( allof([100,110,117,120,130]-rrxo)) error,"##3## Bad rrxo value";
   if( allof([100,105,110,115,120]-rsig)) error,"##3## Bad rsig value";

   curdir = get_cwd();
   cd,"jkve";
   effafile = xb( fmodel, rrxo, rsig, oaa );
   cd, curdir; // return to CrabCal22

   i = where(near(ofax,oaa/60.0,0.1))(1);
   if( i==13 || i==14 ) error,"##3##";
   letter = fmodel == 1 ? "B" : "A";
   rstr = itoa(rrxo)+itoa(rsig)+itoa(oaa)+letter;

   rmfname = "nu"+letter+"cutdet"+itoa(detno(i))+".rmf";
   iden = "crab"+itoa(i+20)+letter;
   scor = itoa(i,2);
   // change to PHAII and update RESPFILE to 'rmfname'
   prep_spec, "PHA_and_corrections/"+iden+".pha",rmffile=rmfname;
   arrange_fit,"PHA_and_corrections/"+iden+"_phaii.pha", effafile, \
       rebin=rebin, id=rstr, \
       aps="PHA_and_corrections/Module"+letter+"correction_cal"+scor+".fits";

   local fqual;
   fitparams = get_xspec_fit_params(rstr+".log",fqual,silent=1);

   lun = open("results.txt","a");
   write,lun,format="%i %i %i %s %.2f %.4f\n", rrxo, rsig, oaa, letter, fitparams(7).value, fqual.red_chi2;
   close, lun;

}
